'**********************************************************
'Compiler            : BASCOM-AVR
'Hardware            : DS2435 an PD.6 (0.5 Grad Auflsung)
'                      LC-Display
'Chip type           : AT90S2313
'**********************************************************

$regfile = "2313def.dat"             'AT90S2313
$crystal = 3579545                   'Quarz 3.579MHz

Config 1wire = Portd.6               'DS2435 DQ an PD6

Dim Ar(2) As Byte                    'Variablenname und Typ festlegen
Dim I As Byte 
Dim Temperatur As Integer
Dim Halb As Byte

Lcd "DS2435 an PB.0"                  'Ausgabe des Textes auf LCD
Wait 3                                'warte 3 Sekunden
Cls                                   'lsche LCD
Lcd "Temp:"                           'Ausgabe des Textes auf LCD
Do                                    'Beginn Schleife
  1wreset                             'Reset DS2435
  1wwrite &HD2                        'starte Temperaturkonvertierung 
  Waitms 100                          'warte 100 Millisekunden
  1wreset                             'Reset DS2435
  1wwrite &HB2                        'aktiviere Temperatur Register 
  1wwrite &H60                        'sende Temperatur Register 60h und 61h
  For I = 1 To 2                      '2x 8 Bit einlesen
    Ar(i) = 1wread()                  'lese 8 Bit von DS2435 in ein Array
  Next                                'die nchsten 8 Bit 
  Locate 2 , 1                        'LCD-Cursor auf Zeile2, Spalte1
  Temperatur = Ar(1)                  'bergebe Temperatur
  Shift Temperatur , Right            'entferne letztes Bit (Rechtsschieben)
  Halb = Ar(1) And 1                  'prfen auf letztes Bit (x.5 Grad)
  If Ar(2) > 127 Then                 'wenn negative Temperatur
    Lcd "-"                           'dann "Minus" auf LCD ausgeben
    Temperatur = 128 - Temperatur     'und negative Temperatur berechnen
    If Halb = 1 Then Temperatur = Temperatur - 1   'wenn Wert x.5 dann um 1 korrigieren
  Else                                'wenn Wert x.0
    Lcd " "                           'dann Leerzeichen auf LCD ausgeben
  End If
  Lcd Temperatur ; ".";                  'Ausgabe Temperatur und Komma
  If Halb = 1 Then Lcd "5" Else Lcd "0"  'wenn x.5 dann "5" nach Komma ausgeben sonst "0"
  Lcd " C "                              'Ausgabe des Textes auf LCD
  Wait 1                                 'warte 1 Sekunde
Loop                                     'zum Beginn der Schleife

End